/* ==========================================================================
 * AnonNet - Anonymous Network Project
 * --------------------------------------------------------------------------
 * Copyright (C) 2001  William Ahern
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 * ==========================================================================
 */

#ifndef _LINK_H
#define _LINK_H 1

#include <openssl/dh.h>

#ifndef _MCRYPT_H
#define _MCRYPT_H
#include <mcrypt.h>
#endif

#include "common.h"
#include "packet.h"

struct link;
typedef struct link link_t;

struct link {
	int sockfd;
	int hopid;
	unsigned char cipher_key[16];
	unsigned char hmac_key[16];
	DH *dh;
	MCRYPT td;
	unsigned short int in_seq;
	unsigned short int out_seq;
	bool encrypted;

	unsigned char lflag;
	unsigned char nflag;

	unsigned char recvbuf[PACKET_SIZE];
	unsigned char sendbuf[PACKET_SIZE];

};

void link_init(link_t *);
void link_destroy(link_t *);

link_t *link_create(void);
void link_free(link_t *);

bool link_readp(link_t *);
void link_writep(link_t *);

bool link_read(link_t *,void *,int);
bool link_write(link_t *,void *,int);

#endif /* _LINK_H */
