/* ==========================================================================
 * AnonNet - Anonymous Network Project
 * --------------------------------------------------------------------------
 * Copyright (C) 2001  William Ahern
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 * ==========================================================================
 */

#include "common.h" 
#include "options.h"
#include "thread.h"

#ifndef _CONF_H
#define _CONF_H 1


/* Defaults */
#ifndef DEFAULT_CONFIG
	#define DEFAULT_CONFIG PACKAGE ## ".conf"
#endif

#ifndef DEFAULT_PORT
	#define DEFAULT_PORT 80
#endif

#ifndef DEFAULT_VERBOSITY
	#define DEFAULT_VERBOSITY 1
#endif

typedef struct {
	Mutex mutex;
	void (*lock)(void);
	void (*unlock)(void);

	unsigned short port;
	unsigned short verbosity;
	bool daemon;
	char *user;
	char *group;
} conf_t;

typedef conf_t *Conf;

Conf conf;

void conf_init(void);
bool conf_parse(void);
void conf_destroy(void);

void conf_lock(void);
void conf_unlock(void);

#endif /* _CONF_H */
