/* ==========================================================================
 * AnonNet - Anonymous Network Project
 * --------------------------------------------------------------------------
 * Copyright (C) 2001  William Ahern
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 * ==========================================================================
 */

#include "netinet/in.h"
#include "sys/types.h"
#include "sys/socket.h"

#include "common.h" 
#include "options.h"
#include "thread.h"
#include "list.h"

#ifndef _CONTROL_H
#define _CONTROL_H 1

#define ADDR_LINK 1
#define ADDR_NODE 2
#define ADDR_OTHR 3


typedef struct {
	char *ipaddress;
	unsigned short int port;
	struct sockaddr_in sin;
} nodeaddr_t;

nodeaddr_t *nodeaddr(void);
void nodeaddr_free(nodeaddr_t *);
List nodeaddr_list(void);


#endif /* _CONTROL_H */
