/* ==========================================================================
 * AnonNet - Anonymous Network Project
 * --------------------------------------------------------------------------
 * Copyright (C) 2001  William Ahern
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 * ==========================================================================
 */

#ifndef _HANDLER_H
#define _HANDLER_H 1

#include "common.h"
#include "packet.h"

#define HANDLER_PASSTHRU 1


struct handler;
typedef struct handler handler_t;
typedef handler_t *Handler;

struct handler {
	int sd;
	int (*init)(Handler,void *,int);
	void (*free)(Handler);
};

Handler get_handler(int);


struct pthru_handler;
typedef struct pthru_handler pthru_handler_t;
typedef pthru_handler_t *PthruHandler;

struct pthru_handler {
	handler_t handler;
};

Handler pthru_create(void);
void pthru_destroy(Handler);
int pthru_init(Handler,void *,int);


#endif /* _HANDLER_H */
