/* ==========================================================================
 * AnonNet - Anonymous Network Project
 * --------------------------------------------------------------------------
 * Copyright (C) 2001  William Ahern
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 * ==========================================================================
 */

#ifndef _LOG_H
#define _LOG_H 1

#include <syslog.h>

#include "common.h"
#include "options.h"

/*
 * Error Routines
 *
 */
#define _ERROR_ 0
#define _WARN_  1
#define _INFO_  2
#define _DEBUG_ 3

#define ERROR(...) log(_ERROR_,__FILE__,__LINE__,__VA_ARGS__)
#define WARN(...)  log(_WARN_,__FILE__,__LINE__,__VA_ARGS__)
#define INFO(...)  log(_INFO_,__FILE__,__LINE__,__VA_ARGS__)
#define DEBUG(...) log(_DEBUG_,__FILE__,__LINE__,__VA_ARGS__)

void log_init(void);
void log(int type,char *file,int line,char *format,...);


#endif /* _LOG_H */
