/* ==========================================================================
 * AnonNet - Anonymous Network Project
 * --------------------------------------------------------------------------
 * Copyright (C) 2001  William Ahern
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 * ==========================================================================
 */

#include <config.h>

#include <stdlib.h>
#include <fcntl.h>
#include <pthread.h>
#include <errno.h>
#include <string.h>

#include "common.h"
#include "log.h"
#include "thread.h"
#include "prng.h"

void rand_init() {
	extern Mutex rand_mutex;
	extern int rand_fd;
	
	rand_mutex = mutex_create();
	rand_fd = open("/dev/urandom",O_RDONLY);
}

void rand_get(void *buf,int bytes) {
	extern Mutex rand_mutex;
	extern int rand_fd;
	int in;
	
	rand_mutex->lock(rand_mutex);

	while (bytes > 0) {
		if ((in = read(rand_fd,buf,bytes)) <= 0) {
			WARN("got EOF or error reading from random source");
			rand_mutex->unlock(rand_mutex);
			return;
		}
		bytes -= in;
		buf += in;
	}

	rand_mutex->unlock(rand_mutex);
	return;
}
