/* ==========================================================================
 * AnonNet - Anonymous Network Project
 * --------------------------------------------------------------------------
 * Copyright (C) 2001  William Ahern
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 * ==========================================================================
 */

#include "thread.h"

#ifndef _SERVER_H
#define _SERVER_H 1

struct server;
typedef struct server server_t;
typedef server_t *Server;

struct server {
	/* Object API */
	Object object;
	void (*bind)(Server);
	void (*release)(Server);
	void (*lock)(Server);
	void (*unlock)(Server);

	/* Thread API */
	Thread thread;
	bool (*start)(Server);
	bool (*isAlive)(Server);
};


Server server_create(void);
void server_destroy(Server);
void server_destructor(void*);

void server_bind(Server);
void release(Server);
void lock(Server);
void unlock(Server);

void *server_thread_entry(void *);
void server_run(Server);
bool server_start(Server);
bool server_is_alive(Server);




#endif /* _SERVER_H */
